diff --git a/game/client/src/main/java/net/betterthanadventure/utils/WikiDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/WikiDumper.java
new file mode 100644
index 000000000..c84a790fb
--- /dev/null
+++ b/game/client/src/main/java/net/betterthanadventure/utils/WikiDumper.java
@@ -0,0 +1,216 @@
+package net.betterthanadventure.utils;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.IPainted;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.tag.ITaggable;
+import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemDiscMusic;
+import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.item.tool.ItemToolPickaxe;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.File;
+import java.io.IOException;
+import java.io.Writer;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+
+/**
+ * Debug utility that dumps every registered block and item into a Lua table
+ * matching the format used by the BTA wiki in Data Value Table.
+ */
+public final class WikiDumper {
+    private WikiDumper() {}
+
+    public static @NotNull File dump(@NotNull File minecraftDir) throws IOException {
+        final File outFile = new File(DumpFolder.resolve(minecraftDir), "wiki_dump.lua");
+        try (Writer writer = Files.newBufferedWriter(outFile.toPath(), StandardCharsets.UTF_8)) {
+            writeDump(writer);
+        }
+        return outFile;
+    }
+
+    private static void writeDump(@NotNull Writer writer) throws IOException {
+        final I18n i18n = I18n.getInstance();
+
+        writer.write("-- Block: { key, namespaceId, id, hardness, blastResistance, miningLevel, stackSize, description, tags }\n");
+        writer.write("-- Item:  { key, namespaceId, id, durability, restores, stackSize, description, tags }\n");
+
+        writer.write("return {\n");
+
+        writer.write("\t[\"Block\"] = {\n");
+        boolean first = true;
+        for (final Block<?> block : Blocks.blocksList) {
+            if (block == null || block.id() == 0) continue;
+
+            if (block.getLogic() instanceof IPainted painted && hasPaintedColorNames(i18n, block.getKey())) {
+                first = writePaintedBlockEntries(writer, i18n, block, painted, first);
+            } else {
+                if (!first) writer.write(",\n");
+                first = false;
+
+                final String name = i18n.translateKey(block.getKey() + ".name");
+                writer.write(formatEntry(name, block.getKey(), block.namespaceId().toString(), String.valueOf(block.id()),
+                    blockExtra(block, block.getKey(), i18n)));
+            }
+        }
+        writer.write("\n\t},\n");
+
+        writer.write("\t[\"Item\"] = {\n");
+        first = true;
+        for (final Item item : Item.itemsList) {
+            if (item == null) continue;
+            if (item.id < Blocks.blocksList.length) continue;
+            first = writeItemEntries(writer, i18n, item, first);
+        }
+        writer.write("\n\t}\n");
+
+        writer.write("}\n");
+    }
+
+    public static @NotNull String getWikiDisplayName(@NotNull Item item, @NotNull I18n i18n) {
+        if (item instanceof ItemDiscMusic disc && disc.recordName != null) {
+            return "Music Disc - " + i18n.translateKey(disc.recordName);
+        }
+        return i18n.translateKey(item.getKey() + ".name");
+    }
+
+    private static boolean writeItemEntries(@NotNull Writer writer, @NotNull I18n i18n, @NotNull Item item, boolean first) throws IOException {
+        final String baseKey = item.getKey();
+        final String namespaceId = item.namespaceID.toString();
+        final String id = String.valueOf(item.id);
+
+        final Map<String, Integer> variants = new LinkedHashMap<>();
+        for (int meta = 0; meta <= DyeColor.MASK_COLOR; meta++) {
+            String languageKey;
+            try {
+                languageKey = item.getLanguageKey(new ItemStack(item, 1, meta));
+            } catch (final Exception e) {
+                languageKey = baseKey;
+            }
+            if (hasTranslation(i18n, languageKey + ".name")) {
+                variants.putIfAbsent(languageKey, meta);
+            }
+        }
+
+        final boolean variesByMetadata = variants.size() > 1
+            || (variants.size() == 1 && !variants.containsKey(baseKey));
+
+        if (!variesByMetadata) {
+            if (!first) writer.write(",\n");
+            writer.write(formatEntry(getWikiDisplayName(item, i18n), baseKey, namespaceId, id, itemExtra(item, baseKey, i18n)));
+            return false;
+        }
+
+        if (!variants.containsKey(baseKey) && hasTranslation(i18n, baseKey + ".name")) {
+            if (!first) writer.write(",\n");
+            first = false;
+            writer.write(formatEntry(getWikiDisplayName(item, i18n), baseKey, namespaceId, id, itemExtra(item, baseKey, i18n)));
+        }
+
+        for (final Map.Entry<String, Integer> variant : variants.entrySet()) {
+            if (!first) writer.write(",\n");
+            first = false;
+            final String name = i18n.translateKey(variant.getKey() + ".name");
+            writer.write(formatEntry(name, variant.getKey(), namespaceId, id + ":" + variant.getValue(),
+                itemExtra(item, variant.getKey(), i18n)));
+        }
+
+        return first;
+    }
+
+    public static boolean hasPaintedColorNames(@NotNull I18n i18n, @NotNull String key) {
+        return hasTranslation(i18n, key + "." + DyeColor.WHITE.colorID + ".name");
+    }
+
+    public static boolean hasTranslation(@NotNull I18n i18n, @NotNull String key) {
+        return !i18n.translateKey(key).equals(key);
+    }
+
+    private static boolean writePaintedBlockEntries(@NotNull Writer writer, @NotNull I18n i18n,
+                                                    @NotNull Block<?> block, @NotNull IPainted painted,
+                                                    boolean first) throws IOException {
+        final String key = block.getKey();
+        final String namespaceId = block.namespaceId().toString();
+        final String id = String.valueOf(block.id());
+
+        int minMeta = Integer.MAX_VALUE;
+        int maxMeta = Integer.MIN_VALUE;
+        for (final DyeColor color : DyeColor.values()) {
+            final int meta = painted.toMetadata(color);
+            minMeta = Math.min(minMeta, meta);
+            maxMeta = Math.max(maxMeta, meta);
+        }
+
+        final String mysteryName = i18n.translateKey(key + ".name");
+        final String mysteryMeta = minMeta == maxMeta ? String.valueOf(minMeta) : "[" + minMeta + "-" + maxMeta + "]";
+        if (!first) writer.write(",\n");
+        first = false;
+        writer.write(formatEntry(mysteryName, key, namespaceId, id + ":" + mysteryMeta, blockExtra(block, key, i18n)));
+
+        for (final DyeColor color : DyeColor.values()) {
+            final String colorKey = key + "." + color.colorID;
+            final String colorName = i18n.translateKey(colorKey + ".name");
+            writer.write(",\n");
+            writer.write(formatEntry(colorName, colorKey, namespaceId, id + ":" + painted.toMetadata(color),
+                blockExtra(block, colorKey, i18n)));
+        }
+
+        return first;
+    }
+
+    private static @NotNull String formatEntry(@NotNull String name, @NotNull String key, @NotNull String namespaceId, @NotNull String id, @NotNull String extra) {
+        return "\t\t[\"" + escape(name) + "\"] = { \"" + key + "\", \"" + namespaceId + "\", \"" + id + "\", " + extra + " }";
+    }
+
+    private static @NotNull String blockExtra(@NotNull Block<?> block, @NotNull String descKey, @NotNull I18n i18n) {
+        final float hardness = block.getHardness();
+        final float blastResistance = block.getBlastResistance(null);
+        final int miningLevel = ItemToolPickaxe.miningLevels.getOrDefault(block, 0);
+        final int stackSize = block.asItem().getItemStackLimit(null);
+        final String description = i18n.translateKey(descKey + ".desc");
+        final String tags = tagList(BlockTags.TAG_LIST, block);
+        return hardness + ", " + blastResistance + ", " + miningLevel + ", " + stackSize
+                + ", \"" + escape(description) + "\", \"" + escape(tags) + "\"";
+    }
+
+
+    private static @NotNull String itemExtra(@NotNull Item item, @NotNull String descKey, @NotNull I18n i18n) {
+        final int durability = item.getMaxDamage();
+        final int restores = item instanceof ItemFood food ? food.getHealAmount(new ItemStack(item)) : 0;
+        final int stackSize = item.getItemStackLimit(null);
+        final String description = i18n.translateKey(descKey + ".desc");
+        final String tags = tagList(ItemTags.TAG_LIST, item);
+        return durability + ", " + restores + ", " + stackSize
+                + ", \"" + escape(description) + "\", \"" + escape(tags) + "\"";
+    }
+
+    private static <T extends ITaggable<T>> @NotNull String tagList(@NotNull List<Tag<T>> tagList, @NotNull T taggable) {
+        final StringBuilder builder = new StringBuilder();
+        for (final Tag<T> tag : tagList) {
+            if (tag.appliesTo(taggable)) {
+                if (!builder.isEmpty()) builder.append(", ");
+                builder.append(tag.getName());
+            }
+        }
+        return builder.toString();
+    }
+
+    private static @NotNull String escape(@NotNull String value) {
+        return value
+                .replace("\\", "\\\\")
+                .replace("\"", "\\\"")
+                .replace("\r", " ")
+                .replace("\n", " ");
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 7ae77976a..943af4200 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1384,7 +1384,7 @@ public class Minecraft
                 if (delta <= 200L) {
                     int scrollDelta = Mouse.getEventDWheel();
                     if (scrollDelta != 0) {
-                        if (this.thePlayer.noPhysics && this.toggleFlyPressed) {
+                        if (this.thePlayer.hasNoPhysics() && this.toggleFlyPressed) {
                             final float steps = 20;
 
                             int step = Math.round(GameSettings.FLIGHT_SPEED.value * steps);
@@ -1415,7 +1415,7 @@ public class Minecraft
             if (this.toggleFlyPressed && !GameSettings.KEY_FLY.isPressed()) {
                 this.toggleFlyPressed = false;
                 if (this.flyPressedTime + 400 > System.currentTimeMillis()) {
-                    this.thePlayer.setNoclip(!this.thePlayer.noPhysics);
+                    this.thePlayer.setNoclip(!this.thePlayer.hasNoPhysics());
                 }
             }
             while (Keyboard.next()) {
@@ -1950,7 +1950,7 @@ public class Minecraft
                 }
             }
             if (controller.digitalPad.left.pressedThisFrame() && this.thePlayer.getGamemode().hasPlayerFlight()) {
-                this.thePlayer.setNoclip(!this.thePlayer.noPhysics);
+                this.thePlayer.setNoclip(!this.thePlayer.hasNoPhysics());
             }
             if (controller.buttonLeftShoulder.pressedThisFrame()) {
                 this.thePlayer.inventory.changeCurrentSlot(1);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 9c354cfe4..46ca4805d 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -92,7 +92,7 @@ public class PlayerLocal extends Player {
     }
 
     public @Nullable AABBdc getCollisionAABB() {
-        if (this.noPhysics) {
+        if (this.hasNoPhysics()) {
             return null;
         } else {
             return super.getCollisionAABB();
@@ -117,7 +117,7 @@ public class PlayerLocal extends Player {
         }
         this.inventoryMenu = newContainer;
         if (!gamemode.hasPlayerFlight()) {
-            this.noPhysics = false;
+            setNoclip(false);
         }
 
         this.fireImmune = gamemode.hasFireImmunity();
@@ -144,7 +144,7 @@ public class PlayerLocal extends Player {
         }
 
         this.prevTimeInPortal = this.timeInPortal;
-        if (this.inPortal && !this.noPhysics) {
+        if (this.inPortal && !this.hasNoPhysics()) {
             if (!this.world.isClientSide && this.vehicle != null) {
                 startRiding(null);
             }
@@ -192,7 +192,7 @@ public class PlayerLocal extends Player {
         checkAndPushInTile(this.x - (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
         checkAndPushInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
         checkAndPushInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z + (double) this.bbWidth * 0.35D);
-        boolean canSprint = this.world.getGameRuleValue(GameRules.ALLOW_SPRINTING) && !this.noPhysics;
+        boolean canSprint = this.world.getGameRuleValue(GameRules.ALLOW_SPRINTING) && !this.hasNoPhysics();
         if (this.onGround && !forwardInput && this.input.moveForward >= f && !isSprinting() && canSprint) {
             if (this.sprintTimer == 0) {
                 this.sprintTimer = 7;
@@ -388,12 +388,19 @@ public class PlayerLocal extends Player {
     public void animate4() {
     }
 
+    @Override
+    public void revokeAchievement(Stat statbase) {
+        if (statbase != null && statbase.isAchievement()) {
+            this.mc.statsCounter.remove(statbase);
+        }
+    }
+
     @Override
     public void addStat(@Nullable Stat stat, int i) {
         if (stat == null) {
             return;
         }
-        if (stat.isAchievement()) {
+        if (i > 0 && stat.isAchievement()) {
             Achievement achievement = (Achievement) stat;
             if (achievement.parent == null || this.mc.statsCounter.isUnlocked(achievement.parent)) {
                 if (!this.mc.statsCounter.isUnlocked(achievement)) {
@@ -404,6 +411,7 @@ public class PlayerLocal extends Player {
         } else {
             this.mc.statsCounter.add(stat, i);
         }
+
     }
 
     @Override
@@ -413,7 +421,7 @@ public class PlayerLocal extends Player {
 
     @Override
     protected boolean checkAndPushInTile(double x, double y, double z) {
-        if (this.noPhysics) return false;
+        if (this.hasNoPhysics()) return false;
         final boolean isShort = this.isDwarf || this.isSneaking();
         final int blockX = MathHelper.floor(x);
         final int blockY = MathHelper.floor(y);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index b0cc54832..556f24d0d 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -150,6 +150,12 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
         }
     }
 
+    @Override
+    public void setNoclip(boolean noclip) {
+        super.setNoclip(noclip);
+        this.sendQueue.addToSendQueue(noclip ? new PacketUpdatePlayerState(PacketUpdatePlayerState.STATE_NO_CLIP) : new PacketUpdatePlayerState(PacketUpdatePlayerState.STATE_DO_CLIP));
+    }
+
     @Override
     public void dropCurrentItem(boolean dropFullStack) {
         sendQueue.addToSendQueue(new PacketPlayerAction(dropFullStack ? PacketPlayerAction.ACTION_DROP_ITEM_STACK : PacketPlayerAction.ACTION_DROP_ITEM_SINGLE, 0, 0, 0, Side.NONE, 0.0, 0.0));
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
index fc4ce6ff5..5ebb6ca53 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
@@ -31,7 +31,7 @@ public class PlayerRemote extends Player
         this.username = username;
         this.uuid = uuid;
         footSize = 0.0F;
-        noPhysics = true;
+        setNoPhysics(true);
         sleepOffY = 0.25F;
         viewScale = 10D;
         
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java b/game/client/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
index f8f270919..9838ff6c8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.window.CursorShape;
 
 public class TexturedButtonElement extends ButtonElement {
     private final String texturePath;
@@ -23,6 +24,11 @@ public class TexturedButtonElement extends ButtonElement {
         mc.textureManager.loadTexture(this.texturePath).bind();
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         boolean isHovered = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
+
+        if (isHovered && this.visible && this.enabled) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+
         if (!this.enabled) {
             drawTexturedModalRect(this.xPosition, this.yPosition, this.u, this.v, this.width, this.height);
         } else if (!isHovered) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 8485dd9dc..1fef0562c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -791,22 +791,31 @@ public class ScreenAchievements extends Screen
         return Math.sin(((double)(System.currentTimeMillis() % period) / period) * Math.PI * 2D) * amplitude;
     }
     private void drawConnectingLines(int mouseX, int mouseY, double shiftX, double shiftY){
+        drawConnectingLinesPass(mouseX, mouseY, shiftX, shiftY, false);
+        drawConnectingLinesPass(mouseX, mouseY, shiftX, shiftY, true);
+    }
+
+    private void drawConnectingLinesPass(int mouseX, int mouseY, double shiftX, double shiftY, boolean unlockedPass){
         double zoom = this.viewportZoom;
 
         for(AchievementPage.AchievementEntry entry : this.currentPage.getAchievementEntries()) {
             Achievement ach = entry.achievement;
-            AchievementPage.AchievementEntry parentEntry = this.currentPage.getEntry(ach.parent);
-            if(parentEntry == null) {
+            Achievement parent = ach.parent;
+            if (parent == null || !this.currentPage.hasAchievement(parent)) {
                 continue;
             }
-            if (!this.currentPage.hasAchievement(ach) || !this.currentPage.hasAchievement(ach.parent)){
+            if (isSecretUndiscovered(ach) || isSecretUndiscovered(parent)) {
+                continue;
+            }
+            boolean unlocked = this.statsCounter.isUnlocked(ach);
+            if (unlocked != unlockedPass) {
                 continue;
             }
+            AchievementPage.AchievementEntry parentEntry = this.currentPage.getEntry(parent);
             double childX = (this.viewportLeft + this.viewportWidth /2d) + ((entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
             double childY = (this.viewportTop + this.viewportHeight /2d) + ((entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
             double parentX = (this.viewportLeft + this.viewportWidth /2d) + ((parentEntry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
             double parentY = (this.viewportTop + this.viewportHeight /2d) + ((parentEntry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
-            boolean unlocked = this.statsCounter.isUnlocked(ach);
             boolean canUnlock = this.statsCounter.canUnlock(ach);
 
             final double zoomOff = 11 * zoom;
@@ -848,6 +857,10 @@ public class ScreenAchievements extends Screen
         }
     }
 
+    public boolean isSecretUndiscovered(@NotNull Achievement achievement) {
+        return achievement.getType().hidden() && !this.statsCounter.isUnlocked(achievement);
+    }
+
     @Nullable
     private Achievement drawAchievementIcons(int mouseX, int mouseY, double shiftX, double shiftY){
         double zoom = this.viewportZoom;
@@ -855,6 +868,7 @@ public class ScreenAchievements extends Screen
         Achievement hoveredAchievment = null;
         for(AchievementPage.AchievementEntry entry : this.currentPage.getAchievementEntries()) {
             Achievement ach = entry.achievement;
+            boolean secretUndiscovered = isSecretUndiscovered(ach);
             double achViewX = (this.viewportLeft + this.viewportWidth /2d) + (entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX ) * zoom;
             double achViewY = (this.viewportTop + this.viewportHeight /2d) + (entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) * zoom;
             if(achViewX < this.viewportLeft - ACHIEVEMENT_CELL_WIDTH * zoom || achViewY < this.viewportTop - ACHIEVEMENT_CELL_HEIGHT * zoom || achViewX > this.viewportRight || achViewY > this.viewportBottom) { // Continue if outside viewport
@@ -864,7 +878,7 @@ public class ScreenAchievements extends Screen
             if(this.statsCounter.isUnlocked(ach)) {
                 float brightness = 1.0F;
                 GLRenderer.setColor4f(brightness, brightness, brightness, 1.0F);
-            } else if(this.statsCounter.canUnlock(ach)) {
+            } else if(!secretUndiscovered && this.statsCounter.canUnlock(ach)) {
                 // Flicker if can unlock
                 float brightness = timeSin(1, 600) >= 0.6 ? 0.6F : 0.8F;
                 GLRenderer.setColor4f(brightness, brightness, brightness, 1.0F);
@@ -876,23 +890,25 @@ public class ScreenAchievements extends Screen
 
             drawGuiIconDouble(achViewX - (ACHIEVEMENT_ICON_WIDTH - ACHIEVEMENT_CELL_WIDTH) * zoom, achViewY - (ACHIEVEMENT_ICON_HEIGHT - ACHIEVEMENT_CELL_HEIGHT) * zoom, ACHIEVEMENT_ICON_WIDTH * zoom, ACHIEVEMENT_ICON_HEIGHT * zoom, this.currentPage.getAchievementIcon(ach));
 
-            if(!this.statsCounter.canUnlock(ach)) {
+            if(!secretUndiscovered && !this.statsCounter.canUnlock(ach)) {
                 float brightness = 0.1F;
                 GLRenderer.setColor4f(brightness, brightness, brightness, 1.0F);
             }
 
-            GLRenderer.pushFrame();
-            GLRenderer.globalSetLightEnabled(true);
-            GLRenderer.enableState(State.CULL_FACE);
-            ItemStack achievementItem = ach.iconStack;
+            if (!secretUndiscovered) {
+                GLRenderer.pushFrame();
+                GLRenderer.globalSetLightEnabled(true);
+                GLRenderer.enableState(State.CULL_FACE);
+                ItemStack achievementItem = ach.iconStack;
 
-            GLRenderer.modelM4f().translate((float) (achViewX + 3 * zoom), (float) (achViewY + 3 * zoom), 0);
-            GLRenderer.modelM4f().scale((float) zoom, (float) zoom, 1);
-//            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
-            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem, 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1f);
+                GLRenderer.modelM4f().translate((float) (achViewX + 3 * zoom), (float) (achViewY + 3 * zoom), 0);
+                GLRenderer.modelM4f().scale((float) zoom, (float) zoom, 1);
+    //            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
+                ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem, 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1f);
 
-            GLRenderer.globalSetLightEnabled(false);
-            GLRenderer.popFrame();
+                GLRenderer.globalSetLightEnabled(false);
+                GLRenderer.popFrame();
+            }
 
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
@@ -904,10 +920,21 @@ public class ScreenAchievements extends Screen
         return hoveredAchievment;
     }
     private void drawAchievementToolTip(Achievement achievement, int mouseX, int mouseY){
-        String name = achievement.getStatName();
-        String desc = achievement.getDescription();
         final int padding = this.tooltip.getPadding();
         int[] boxRender;
+        if (isSecretUndiscovered(achievement)) {
+            String name = I18n.getInstance().translateKey("gui.achievements.label.secret");
+            String desc = I18n.getInstance().translateKey("gui.achievements.label.secret.desc");
+            int boxWidth = Math.max(Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(name)), MathHelper.ceil(this.fontRenderer.stringWidthDouble(desc))), TOOLTIP_BOX_WIDTH_MIN);
+            int boxHeight = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(desc, boxWidth));
+            boxRender = this.tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
+            this.fontRenderer.renderWidthConstrained(desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xff705050).call();
+            drawStringShadow(this.fontRenderer, name, boxRender[0] + padding, boxRender[1] + padding, achievement.getType().colorNameLocked());
+            return;
+        }
+
+        String name = achievement.getStatName();
+        String desc = achievement.getDescription();
         if(this.statsCounter.canUnlock(achievement)) { // Can unlock/ is unlocked
             int boxWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(name)), TOOLTIP_BOX_WIDTH_MIN);
             int boxHeight = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(desc, boxWidth));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index 9d8b31348..2f5448dad 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -52,17 +52,39 @@ public class AchievementPages {
         overworldPage.addAchievement(Achievements.TRIPLE_HIT, 11, -2);
 
         netherPage = register(new AchievementPageNether("gui.achievements.page.nether", Blocks.COBBLE_NETHERRACK.getDefaultStack()));
-        netherPage.addAchievement(Achievements.ENTER_NETHER, 2, 0);
-        netherPage.addAchievement(Achievements.GET_NETHERCOAL, 1, 2);
-        netherPage.addAchievement(Achievements.LIGHT_SIGN, 4, 0);
-        netherPage.addAchievement(Achievements.SWIM_NETHER, 3, 2);
-        netherPage.addAchievement(Achievements.HIT_FIREBALL, 3, -2);
-        netherPage.addAchievement(Achievements.SLEEP_NETHER, 1, -2);
 //        netherPage.addAchievement(Achievements.ENTER_WARRENS, 0, 5);
-        netherPage.addAchievement(Achievements.MOST_WANTED, 0, -1);
-        netherPage.addAchievement(Achievements.FAST_TRAVEL, 0, 1);
-        netherPage.addAchievement(Achievements.GET_STEEL_BLAST_FURNACE, 0, 4);
-        netherPage.addAchievement(Achievements.OBTAIN_STEEL, -2, 4);
+
+        netherPage.addAchievement(Achievements.ENTER_NETHER, 0, 0);
+        netherPage.addAchievement(Achievements.MOST_WANTED, -2, 1);
+        netherPage.addAchievement(Achievements.FAST_TRAVEL, 2, 1);
+        netherPage.addAchievement(Achievements.DISCOVER_SULFURPOOLS, 4, 0);
+        netherPage.addAchievement(Achievements.COLLECT_ACID, 5, 2);
+        netherPage.addAchievement(Achievements.CONVERT_ACID_TO_SULFUR,  7, 2);
+        netherPage.addAchievement(Achievements.CRAFT_ACID_COBBLE_TO_STONE, 6, 1);
+        netherPage.addAchievement(Achievements.CONVERT_ACID_TO_STONE, 6, 3);
+        netherPage.addAchievement(Achievements.ACID_BATH, 7, -1);
+        netherPage.addAchievement(Achievements.LIGHT_SIGN, 2, -1);
+        netherPage.addAchievement(Achievements.DISCOVER_VOLCANICISLANDS, -4, 0);
+        netherPage.addAchievement(Achievements.FLING_VENT, -4, 2);
+        netherPage.addAchievement(Achievements.WHAT_WAS_THAT, -6, 1);
+        netherPage.addAchievement(Achievements.COLLECT_PUMICE, -6, -1);
+        netherPage.addAchievement(Achievements.GET_NETHERCOAL, -1, -2);
+        netherPage.addAchievement(Achievements.GET_STEEL_BLAST_FURNACE, -3, -3);
+        netherPage.addAchievement(Achievements.OBTAIN_STEEL, -5, -3);
+        netherPage.addAchievement(Achievements.CRAFT_STEEL_BUCKET, -6, -4);
+        netherPage.addAchievement(Achievements.DISCOVER_CRYSTALFOREST, 0, 4);
+        netherPage.addAchievement(Achievements.COLLECT_RUBYGLASS, 2, 4);
+        netherPage.addAchievement(Achievements.CRAFT_CONDUIT, 3, 3);
+        netherPage.addAchievement(Achievements.SWIM_NETHER, -2, 3);
+        netherPage.addAchievement(Achievements.DISCOVER_OLDWORLD, 0, -4);
+        netherPage.addAchievement(Achievements.TRIGGER_EMBER, -2, -5);
+        netherPage.addAchievement(Achievements.HIT_FIREBALL, 2, -3);
+        netherPage.addAchievement(Achievements.SLEEP_NETHER, 4, -4);
+
+
+
+
+
     }
     static {
         init();
